#include <sstream>
#include <cmath>
#include <cctype>

using namespace std;

#include "basfun.hh"
long long int BasMODop(long long int a, long long int b)
{
    bool nega = a < 0;
    if(nega) a = -a;
    if(b < 0) b = -b;
    
    if(b == 0)
    {
        B_ERROR(11); // Division by zero
    }
    
    long long int result = a % b;
    return nega ? -result : result;
}

long long int BasCINT(long double a)
{
    if(a > 32767 || a < -32768) { B_ERROR(6); /* OVERFLOW */ }
    return (long long int)floorl(a + 0.5);
}
long long int BasCLNG(long double a)
{
    if(a > 0x7FFFFFFFL || a < -0x80000000UL) { B_ERROR(6); /* OVERFLOW */ }
    return (long long int)floorl(a + 0.5);
}

long long int BasINT(long double a)
{
    if(a > 32767 || a < -32768) { B_ERROR(6); /* OVERFLOW */ }
    return (long long int)(a);
}

long double BasVAL(const std::string& s)
{
    int base = 10;
    unsigned startpos = 0;
    if(s.size() >= 2 && s[0] == '&')
    {
        if(s[1] == 'H' || s[1] == 'h') { startpos = 2; base = 16; }
        if(s[1] == 'O' || s[1] == 'o') { startpos = 2; base = 8; }
        if(s[1] == 'B' || s[1] == 'b') { startpos = 2; base = 2; }
    }
    char* endpos;
    long double result;
    if(base == 10)
        result = strtold(s.c_str(), &endpos);
    else
        result = strtoll(s.c_str(), &endpos, base);
   
    if(*endpos)
    {
        // TODO: ERROR "invalid function call"
    }
    
    return result;
}

const std::string BasLCASE(const std::string& s)
{
    std::string result = s;
    for(unsigned a=0; a<result.size(); ++a)
        result[a] = std::tolower(result[a]);
    return result;
}

const std::string BasUCASE(const std::string& s)
{
    std::string result = s;
    for(unsigned a=0; a<result.size(); ++a)
        result[a] = std::toupper(result[a]);
    return result;
}


const std::string BasSTRs(long double a)
{
    std::stringstream s;
    s << ' ' << a;
    return s.str();
}

const std::string BasCHRs(long long int a)
{
    if(a < 0 || a > 255)
    {
        B_ERROR(5); // Invalid function call
    }

    std::string s;
    s += (char)a;
    return s;
}
