template<typename T,unsigned Ndims>
BAS_DYNARRAY<T,Ndims>::BAS_DYNARRAY(empty_struct, ...)
    : BAS_MAGICARRAY_ImplSTATIC<T>(&data[0], Ndims)
{
    va_list ap;
    va_start(ap, empty_struct);
    BAS_MAGICARRAY_ImplSTATIC<T>::InitDims(ap);
    va_end(ap);
    RedimUpdate();
}

template<typename T,unsigned Ndims>
T& BAS_DYNARRAY<T,Ndims>::Index(unsigned numdims, ...)
{
    va_list ap;
    va_start(ap,numdims);
    T& res = DoIndex(numdims, ap);
    va_end(ap);
    return res;
}

template<typename T,unsigned Ndims>
T& BAS_DYNARRAY<T,Ndims>::DoIndex(unsigned numdims, va_list ap)
{
    return BAS_MAGICARRAY_ImplSTATIC<T>::Index(numdims, ap);
}

template<typename T,unsigned Ndims>
void BAS_DYNARRAY<T,Ndims>::Redim(unsigned numdims, ...)
{
    va_list ap;
    va_start(ap,numdims);
    DoRedim(numdims,ap);
    va_end(ap);
}

template<typename T,unsigned Ndims>
void BAS_DYNARRAY<T,Ndims>::DoRedim(unsigned numdims, va_list ap)
{
    if(numdims != Ndims) { B_ERROR(9); return; }
    container.clear();
    BAS_MAGICARRAY_ImplSTATIC<T>::InitDims(ap);
    RedimUpdate();
}

template<typename T,unsigned Ndims>
void BAS_DYNARRAY<T,Ndims>::RedimUpdate()
{
    container.resize(Volume());
    data = &container[0];
}

template<typename T,unsigned Ndims>
void BAS_DYNARRAY<T,Ndims>::Erase()
{
    container.clear();
    for(unsigned a=0; a<Ndims; ++a)
    {
        dims[a].first = 0;
        dims[a].second = 0;
    }
}
